'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slatePluginsCommon = require('@udecode/slate-plugins-common');
var slatePluginsCore = require('@udecode/slate-plugins-core');
var slate = require('slate');

const insertDeserializedFragment = (editor, {
  fragment,
  plugins
}) => {
  slate.Editor.withoutNormalizing(editor, () => {
    plugins.forEach(({
      deserialize
    }) => {
      const getFragment = deserialize === null || deserialize === void 0 ? void 0 : deserialize(editor).getFragment;
      if (!getFragment) return;
      fragment = getFragment(fragment);
    });
    if (!fragment.length) return;
    const preInserted = plugins.some(({
      deserialize
    }) => {
      var _deserialize$preInser, _deserialize;

      return (deserialize === null || deserialize === void 0 ? void 0 : (_deserialize$preInser = (_deserialize = deserialize(editor)).preInsert) === null || _deserialize$preInser === void 0 ? void 0 : _deserialize$preInser.call(_deserialize, fragment)) === true;
    });

    if (!preInserted) {
      const inlineTypes = slatePluginsCore.getInlineTypes(editor, plugins);
      const firstNodeType = fragment[0].type; // replace the selected node type by the first block type

      if (slatePluginsCommon.isBlockAboveEmpty(editor) && firstNodeType && !inlineTypes.includes(firstNodeType) && fragment[0].type) {
        slatePluginsCommon.setNodes(editor, {
          type: firstNodeType
        });
      }
    }

    editor.insertFragment(fragment);
  });
};

exports.insertDeserializedFragment = insertDeserializedFragment;
//# sourceMappingURL=index.js.map
